var action, codeDiv, codeType;

function init() {
	tinyMCEPopup.resizeToInnerSize();

	var inst = tinyMCE.getInstanceById(tinyMCE.getWindowArg('editor_id'));
	codeDiv = tinyMCE.getParentElement(inst.getFocusElement(), "div", function(n)
	    {
	        return n.parentNode && n.parentNode.tagName == "DIV" && n.parentNode.className == "code";
	    });
	action = 'insert';

	document.forms[0].insert.value = tinyMCE.getLang('lang_' + action, 'Insert', true);
	getAuthorizedLanguages();
	resizeInputs();
}

function insertCode() {
	codeType = document.forms[0].codeType.options[document.forms[0].codeType.selectedIndex].value;
	var codeLegend = document.forms[0].codeLegend.value;
	var code = document.forms[0].codeContent.value;
	
	var urlParams = 'lang='+codeType+'&legend='+encodeURIComponent(codeLegend)
					+'&code='+encodeURIComponent(code);
	highlightAndSetCode(urlParams);
	if(tinyMCE.isGecko) {
	   // workaround a FF bug   
	   setTimeout(function(){tinyMCEPopup.close();},1000);
	} else {
	   tinyMCEPopup.close();
	}
}

function doInsertCode(code) {
	var inst = tinyMCE.getInstanceById(tinyMCE.getWindowArg('editor_id'));
	tinyMCEPopup.execCommand("mceBeginUndoLevel");

	if (action == "update") {
		codeDiv.className = codeType;
		codeDiv.innerHTML = '';
		codeDiv.innerHTML = code;
	} else {
		var rng = inst.getRng();

		if (rng.collapse)
			rng.collapse(false);
		
		tinyMCEPopup.execCommand("mceInsertContent", false, '<div class=\"code\"><div class=\"' + codeType + '\">' + code+'</div></div><p></p>');
		tinyMCE.handleVisualAid(inst.getBody(), true, inst.visualAid, inst);
	}

	tinyMCEPopup.execCommand("mceEndUndoLevel");

	tinyMCE.triggerNodeChange();
}

var wHeight=0, wWidth=0;

function resizeInputs() {
	if (!tinyMCE.isMSIE) {
		 wHeight = self.innerHeight-140;
		 wWidth = self.innerWidth-16;
	} else {
		 wHeight = document.body.clientHeight - 155;
		 wWidth = document.body.clientWidth - 16;
	}

	document.forms[0].codeContent.style.height = Math.abs(wHeight) + 'px';
	document.forms[0].codeContent.style.width  = Math.abs(wWidth) + 'px';
	document.forms[0].codeLegend.style.width  = Math.abs(wWidth) + 'px';
}

// AJAX Handling
function createRequestObject() {
    var ro;
    var browser = navigator.appName;
    if(browser == "Microsoft Internet Explorer"){
        ro = new ActiveXObject("Microsoft.XMLHTTP");
    }else{
        ro = new XMLHttpRequest();
    }
    return ro;
}


function highlightAndSetCode(urlParams) {
    var http = createRequestObject();
	http.open('POST', tinyMCE.baseURL+'/plugins/insertcode/webservice/get_highlighted_code.php', false);
	http.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	http.send(urlParams);
    if (http.status==200) {
	    doInsertCode(http.responseText);
	    return true;
    } else {
	    alert("Problem retrieving data:" + http.statusText);
	    return false;
    }
}

function deleteHighlighting(withTags) {
    
    var stripped = withTags.replace(/\n/gi, "");
    var stripped = stripped.replace(/\r/gi, "");
    
    // Remove very first <li >
    var stripped = stripped.replace(/\<li[^\>]*\>/i, "");

    // Replace following <li >'s with newlines.    
    var stripped = stripped.replace(/\<li[^\>]*\>/gi, "\n");
    
    // Remove all remaining tags
    var stripped = stripped.replace(/\<[^\>]*\>/gi, "");
    
    var stripped = stripped.replace(/\&nbsp\;/gi, " ");
    var stripped = stripped.replace(/\&amp\;/gi, "&");
    var stripped = stripped.replace(/\&lt\;/gi, "<");
    var stripped = stripped.replace(/\&gt\;/gi, ">");
    var stripped = stripped.replace(/\&quot\;/gi, "\"");
    
    document.forms[0].codeContent.value = stripped;
    return true;
}

function getAuthorizedLanguages() {
    var http = createRequestObject();
	http.open('GET', tinyMCE.baseURL+'/plugins/insertcode/webservice/get_auth_lang.php', false);
	http.send(null);	
    if (http.status==200) {
	    document.getElementById('codeTypeCt').innerHTML = http.responseText;
		            	    
        if (codeDiv != null) {
		    action = "update";
		    document.forms[0].insert.value = tinyMCE.getLang('lang_' + action, 'Insert', true); 
		    // set the selected language
    	    for(var i=0;i<document.forms[0].codeType.options.length;i++)
    	      if(document.forms[0].codeType.options[i].value == codeDiv.className )
    	        document.forms[0].codeType.selectedIndex = i;
					
		    // get the legend (if any)
		    if((head = tinyMCE.getElementByAttributeValue(codeDiv, 'div', 'class', 'head')) != null)
		       document.forms[0].codeLegend.value = head.innerHTML;
	
		    // get the source code
		    var olArr = codeDiv.getElementsByTagName('ol');
		    var ol = olArr[0];
	
		    deleteHighlighting(ol.innerHTML);
	    }
	    return true;
    } else {
	    alert("Problem retrieving data:" + http.statusText);
	    return false;
    }
}